﻿var theScriptName = "Apply object style to group";
var d = app.activeDocument;
var s = app.selection[0];
if (!(s instanceof Group)){
	alert("Please select a Group and try again!", theScriptName);
	exit();
}
var allObjectStyles = app.activeDocument.allObjectStyles;
showUI();
var myStyle = allObjectStyles[styleDropdown.selection.index];
var gs = []; // Array of all the styles in the group
var pi = s.allPageItems;
var i;
for (i = 0; i < pi.length; i++){
	gs.push(pi[i].properties);
}
s.applyObjectStyle(myStyle, true, true);
for (i = 0; i < pi.length; i++){
	pi[i].properties = gs[i];
}

function showUI(){
	w = new Window("dialog", theScriptName);
	w.preferredSize.width = 400;
	with (w){
		with (add("group")){
			alignment = ["fill", "fill"];
			alignChildren = "fill";
			styleDropdown = add("dropdownlist", undefined, getAllStyles(app.activeDocument.allObjectStyles, ObjectStyleGroup));
			styleDropdown.title = "Style: ";
			styleDropdown.selection = 0;
		}
		with (add("group")){
			alignment = ["right", "bottom"];
			OKButton = add("button", undefined, "OK");
			OKButton.characters = 12;
			CancelButton = add("button", undefined, "Cancel");
			CancelButton.characters = 12;
		}
	}
	var r = w.show();
	if (r == 2){
		exit();
	}
}

function getAllStyles(allStyles, groupObj){
	var i;
	var s = [];
	for (i = 0; i < allStyles.length; i++){
		s.push(getFullName(allStyles[i], groupObj));
	}
	return s;
	
	function getFullName(styleObj, groupObj){
		var climbing = styleObj.parent;
		var s = styleObj.name;
		var g = "";
		while (climbing instanceof groupObj){
			if (g != "") g =  ":" + g;
			g = climbing.name + g;
			climbing = climbing.parent;
		}
		if (g != ""){
			g = " ("+g+")";
			s = s + g;
		}
		return s;
	}
}
